#!/bin/bash
set -x



COUNTRY=US
STATE=NY
O="International Business Machines Corporation"
OU=SPP

CERT_DIR=/opt/ECX/spp/cert
mkdir -p $CERT_DIR 


# TODO , don't generate/replace certificate if CA cert is used

openssl req  -newkey rsa:2048  -nodes -keyout ${CERT_DIR}/spp.key -x509 -days 3650 -out ${CERT_DIR}/spp.crt  -subj "/C=${COUNTRY}/ST=${STATE}/O=${O}/OU=${OU}/CN=$(hostname)" 

if [ $? -ne 0 ]; then
    echo "Failed to generate certificate"
    exit 1
fi
openssl pkcs12 -export -in ${CERT_DIR}/spp.crt -inkey ${CERT_DIR}/spp.key -chain -CAfile ${CERT_DIR}/spp.crt -name spp -out ${CERT_DIR}/spp.p12 -password pass:ecx-beta

if [ $? -ne 0 ]; then
    echo "Failed to export certificate in pkcs12 format"
    exit 1
fi


cp ${CERT_DIR}/spp.p12 /opt/ECX/guesttools/linux/vadpproxy/spp.p12
if [ $? -ne 0 ]; then
    echo "Failed to stage pkcs12 certificate."
    exit 1
fi


echo "Preserving old certificate in /opt/virgo/configuration/*.prev"
cp -f /opt/virgo/configuration/ecx-beta.key /opt/virgo/configuration/ecx-beta.key.prev
cp -f /opt/virgo/configuration/ecx-beta.crt  /opt/virgo/configuration/ecx-beta.prev


echo "Updating old certificate in /opt/virgo/configuration/"

cp -f ${CERT_DIR}/spp.key /opt/virgo/configuration/ecx-beta.key
cp -f ${CERT_DIR}/spp.crt /opt/virgo/configuration/ecx-beta.crt


systemctl restart reverse-proxy



